package cz.zweistein.df.soundsense;

import java.io.IOException;
import java.util.logging.Logger;

import org.xml.sax.SAXException;

import cz.zweistein.df.soundsense.config.ConfigurationXML;
import cz.zweistein.df.soundsense.config.SoundsXML;
import cz.zweistein.df.soundsense.glue.Glue;
import cz.zweistein.df.soundsense.input.file.LogReader;
import cz.zweistein.df.soundsense.output.Procesor;
import cz.zweistein.df.soundsense.output.sound.SoundProcesor;
import cz.zweistein.df.soundsense.util.LoggerSource;

public class SoundSense {
	private static Logger logger = LoggerSource.logger;
	
	public static void main(String[] args) {
		
		try {
			
			ConfigurationXML configuration = new ConfigurationXML("configuration.xml");
			
			logger.info("SoundSense for Dwarf Fortress is starting...");
			logger.info("Loading theme packs from "+configuration.getSoundpacksPath());
			SoundsXML soundsXML = new SoundsXML(configuration.getSoundpacksPath());
			logger.info("Done loading "+configuration.getSoundpacksPath()+", loaded "+soundsXML.getSounds().size()+" items.");
			
			logger.info("Attempting to listen to "+configuration.getGamelogPath());
			LogReader logReader = new LogReader(configuration.getGamelogPath());
			logger.info("Listening to "+configuration.getGamelogPath());
			
			SoundProcesor sp = new SoundProcesor(soundsXML);
			sp.setGlobalVolume(configuration.getVolume());
			
			Glue.glue(logReader, sp);
			
			//NetworkManager nm = new NetworkManager(sp);
			//nm.acceptIcommingConnections(3333);
			
		} catch (IOException e) {
			logger.severe("Exception :"+e+": "+e.toString());
		} catch (SAXException e) {
			logger.severe("Exception :"+e+": "+e.toString());
		}
		
	}

}
